package com.xiaoniu.subsystem.system.controller;

import com.xiaoniu.common.core.utils.poi.ExcelUtil;
import com.xiaoniu.common.core.web.controller.BaseController;
import com.xiaoniu.common.core.web.domain.AjaxResult;
import com.xiaoniu.common.core.web.page.TableDataInfo;
import com.xiaoniu.common.log.annotation.Log;
import com.xiaoniu.common.log.enums.BusinessType;
import com.xiaoniu.common.security.annotation.InnerAuth;
import com.xiaoniu.common.security.annotation.RequiresPermissions;
import com.xiaoniu.subsystem.system.domain.dto.SysOperLogQueryDTO;
import com.xiaoniu.subsystem.system.service.ISysOperLogService;
import com.xiaoniu.system.api.domain.SysOperLog;
import io.swagger.v3.oas.annotations.Operation;
import io.swagger.v3.oas.annotations.tags.Tag;
import jakarta.servlet.http.HttpServletResponse;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.List;

/**
 * 操作日志记录
 *
 * @author xiaoniu
 */
@RestController
@RequestMapping("/operlog")
@Tag(name = "操作日志信息", description = "公告信息接口")
public class SysOperlogController extends BaseController {
    @Autowired
    private ISysOperLogService operLogService;

    //@RequiresPermissions("system:operlog:list")
    @GetMapping("/list")
    @Operation(summary = "列表")
    public TableDataInfo list(SysOperLogQueryDTO dto) {
        startPage();
        List<SysOperLog> list = operLogService.getOperLogList(dto);
        return getDataTable(list);
    }

    @Log(title = "操作日志", businessType = BusinessType.EXPORT)
    //@RequiresPermissions("system:operlog:export")
    @PostMapping("/export")
    @Operation(summary = "导出列表")
    public void export(HttpServletResponse response, SysOperLogQueryDTO dto) {
        List<SysOperLog> list = operLogService.getOperLogList(dto);
        ExcelUtil<SysOperLog> util = new ExcelUtil<SysOperLog>(SysOperLog.class);
        util.exportExcel(response, list, "操作日志");
    }

    @Log(title = "操作日志", businessType = BusinessType.DELETE)
    //@RequiresPermissions("system:operlog:remove")
    @DeleteMapping("/{operIds}")
    @Operation(summary = "删除")
    public AjaxResult remove(@PathVariable Long[] operIds) {
        return toAjax(operLogService.deleteOperLogByIds(operIds));
    }

    //@RequiresPermissions("system:operlog:remove")
    @Log(title = "操作日志", businessType = BusinessType.CLEAN)
    @DeleteMapping("/clean")
    @Operation(summary = "清空")
    public AjaxResult clean() {
        operLogService.cleanOperLog();
        return success();
    }

    @InnerAuth
    @PostMapping
    public AjaxResult add(@RequestBody SysOperLog operLog) {
        return toAjax(operLogService.insertOperlog(operLog));
    }
}
